window.onload = function () {
    var spread;
    // spread.fromJSON(jsonData);
    var excelIo;
    var fileName = "";
    document.getElementById('loadExcel').onclick = function () {
        var grapecitySpread = GC.Spread;
        var spreadNS = GC.Spread.Sheets;
        spread = new grapecitySpread.Sheets.Workbook(document.getElementById("ss"), { calcOnDemand: true });
        excelIo = new grapecitySpread.Excel.IO();
        var excelFile = document.getElementById("fileDemo").files[0];
        fileName = excelFile.name.split(".")[0];
        // here is excel IO API
        excelIo.open(excelFile, function (json) {
            var workbookObj = json;
			spread.fromJSON(workbookObj);
            var sheetAReq = spread.getSheetFromName("A Req Sheet");
            sheetAReq.suspendPaint();
            var customFloatingObject = new grapecitySpread.Sheets.FloatingObjects.FloatingObject("f0");
            customFloatingObject.startRow(11);
            customFloatingObject.startColumn(22);
            customFloatingObject.height(150);
            customFloatingObject.width(200);
            customFloatingObject.allowResize(false);
            customFloatingObject.allowMove(false);
            var div = document.createElement('div');
            div.style.height = "100%";
            div.style.width = "100%";
            div.innerHTML = `<img style='height="100%"; width="100%"' src=${base64} />`;
            customFloatingObject.content(div);
            sheetAReq.floatingObjects.add(customFloatingObject);
            sheetAReq.setText(57, 1, "O");
            sheetAReq.setText(57, 16, "A");
            sheetAReq.setText(58, 1, "（○）");
            sheetAReq.setText(58, 16, "B");
            let rank = sheetAReq.getValue(61, 6);
            console.log(rank);
            if (rank === '（○）') {
                let colStyle = sheetAReq.getStyle(58,1);
                colStyle.backColor = "#f7a711";
                sheetAReq.setStyle(58, 1, colStyle, GC.Spread.Sheets.SheetArea.viewport);
            }
            sheetAReq.resumePaint();
            // var formatter = sheetAReq.getFormatter(11, 22);
            // console.log(formatter);
            // sheetAReq.setFormula(11, 22, '=IMAGE("' + base64+ '",4,50,150)');
            
            // sheetAReq.setRowHeight(11, 50, GC.Spread.Sheets.SheetArea.viewport);
            // sheetAReq.setColumnWidth(22, 150, GC.Spread.Sheets.SheetArea.viewport);
            // var sheet = spread.getSheetFromName("RANK");
            var activeSheet = spread.getActiveSheet();
            activeSheet.bind(grapecitySpread.Sheets.Events.EditStarting, function (sender, args) {
                if (args.row === 61 && args.col == 6) {
                    args.cancel = true;
                }
            });
            activeSheet.getDataValidator(61,6).inCellDropdown(false);
            activeSheet.resumePaint();

        }, function (e) {
            // process errorm
            alert(e.errorMessage);
        });
    };
    document.getElementById('saveExcel').onclick = function () {

        var fileName = document.getElementById('exportFileName').value;
        if (fileName.substr(-5, 5) !== '.xlsx') {
            fileName += '.xlsx';
        }

        var json = spread.toJSON();

        // here is excel IO API
        excelIo.save(json, function (blob) {
            saveAs(blob, fileName);
        }, function (e) {
            // process error
            console.log(e);
        });

    };

    document.getElementById('savePDF').onclick = function () {
        // var font = {
        //     normal: fonts['Msgothic_02.ttf']
        // };
        // GC.Spread.Sheets.PDF.PDFFontsManager.registerFont('ms pゴシック', font);
        console.log(fileName);
        var name = (fileName ? fileName : 'download') + ".pdf";
        spread.savePDF(
            function (blob) {
                saveAs(blob, name);
            },
            console.log,
            {
                title: 'Test Title',
                author: 'Test Author',
                subject: 'Test Subject',
                keywords: 'Test Keywords',
                creator: 'test Creator'
            });
    };
};
